/*
  <<<<< 񏈗SFpthread_mutex_trylockɂ郉CubN{ɋN >>>>>

  int ̔zf[^Q̕@ŉZB
    1.intTCYŉZ
    2.shortTCYŉZ
      a).shortTCYZ2ōs
         ォƉ2𓮂AԂƂŏI

   vOŔzvfw
     wvfintz0`w萔܂ł̒l
     KvȂǁAZOɈꉞVbtB

   r}

  RpC@Fgcc -lpthread -o sample1_4_1 sample1_4_1.c
        Fsample1_4_1.exe  100000
 */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <errno.h>
#define Lock_P1 if(pthread_mutex_lock(p1)) printf(" Mutex Lock Error (p1)\n") /* ;else  printf(" Mutex Lock (p1)\n") */
#define Lock_P2 if(pthread_mutex_lock(p2)) printf(" Mutex Lock Error (p2)\n") /* ;else  printf(" Mutex Lock (p2)\n") */
#define TryLock_P1 (pthread_mutex_trylock(p1))
#define TryLock_P2 (pthread_mutex_trylock(p2))
#define Unlock_P1 if(pthread_mutex_unlock(p1)) printf(" Mutex Unlock Error (p1)\n") /* ;else  printf(" Mutex Unlock (p1)\n") */
#define Unlock_P2 if(pthread_mutex_unlock(p2)) printf(" Mutex Unlock Error (p2)\n") /* ;else  printf(" Mutex Unlock (p2)\n") */
int	count,*array;
unsigned int	int_sum,short_sum;
unsigned short short_sum_u,short_sum_l;
int	now_top,now_end;
pthread_t thread_top;
pthread_t thread_end;

pthread_mutex_t mutex_u;	// mutexϐ錾P
pthread_mutex_t mutex_l;	// mutexϐ錾Q

void shuffle(int *p, int num)
{
  int i,j,k;

  for( i = 0 ; i < num ; i++ )
  {
    j = rand() % num;
    k = *(p+i);
    *(p+i) = *(p+j);
    *(p+j) = k;
  }
}

void add_int(int num)
{
  int i,*p;

  for( i = 0, p = array ; i < num ; i++ )
    int_sum += *p++;
}

void add_short_top(int *nump)
{
  int num=*nump,i,*p;
  unsigned short u,l;
  pthread_mutex_t *p1=&mutex_l,*p2=&mutex_u,*pw;

  for( i = 0, p = array ; i < num ; )
  {
    if ( i >= now_end )
      break;
    now_top=i;
    l = *p & 0xFFFF;
    u = (*p >> 16) & 0xFFFF;
    for ( ; ; )
    {
      Lock_P1;                    // Lock p1
      if ( TryLock_P2 == EBUSY )  // Lock p2
      {
	usleep(1);
	Unlock_P1;
	pw = p1, p1 = p2, p2 = pw;
//	printf("Busy:Top (%d)\n",i);
	continue;
      }
      break;
    }
    short_sum_l += l;
    short_sum_u += u;
    if (short_sum_l < l)
      short_sum_u++;
    Unlock_P1;               // Unlock p1
    Unlock_P2;               // Unlock p2
    p++;
    i++;
  }
  pthread_exit(NULL);
}

void add_short_end(int *nump)
{
  int num=*nump,i,*p;
  unsigned short u,l;
  pthread_mutex_t *p1=&mutex_l,*p2=&mutex_u,*pw;

  for( i = num-1, p = array+(num-1) ; i >= 0 ; )
  {
    if ( i <= now_top )
      break;
    now_end=i;
    u = (*p >> 16) & 0xFFFF;
    l = *p & 0xFFFF;
    for ( ; ; )
    {
      Lock_P2;                    // Lock p2
      if ( TryLock_P1 == EBUSY )  // Lock p1
      {
//	usleep(1);
	Unlock_P2;
	pw = p1, p1 = p2, p2 = pw;
//	printf("Busy:End (%d)\n",i);
	continue;
      }
      break;
    }
    short_sum_u += u;
    short_sum_l += l;
    if (short_sum_l < l)
      short_sum_u++;
    Unlock_P2;               // Unlock p2
    Unlock_P1;               // Unlock p1
    p--;
    i--;
  }
  pthread_exit(NULL);
}

void add_short(int num)
{
  if ( pthread_mutex_init(&mutex_u,NULL) )	// mutexϐP̏
    printf(" Mutex U Init Error\n");
  if ( pthread_mutex_init(&mutex_l,NULL) )	// mutexϐQ̏
    printf(" Mutex L Init Error\n");
  now_top = 0, now_end = num-1;
  if ( pthread_create(&thread_top,NULL,(void *)add_short_top,(void *)&num) )
    printf(" Thread Create Error (add_short_top)\n");
  if ( pthread_create(&thread_end,NULL,(void *)add_short_end,(void *)&num) )
    printf(" Thread Create Error (add_short_end)\n");
  
  if ( pthread_join(thread_top,NULL) )
        printf(" Thread Join Error (add_short_top)\n");
  if ( pthread_join(thread_end,NULL) )
        printf(" Thread Join Error (add_short_end)\n");
}

int main(int argc, char *argv[])
{
  int i,*p;

  if ( argc != 2 )
  {
    fprintf(stderr," Error !!\n");
    return 1;
  }
  count	= atoi(argv[1]);
  if ( count <= 0 )
  {
    fprintf(stderr," Error !!!\n");
    return 1;
  }

  printf(" Count = %d\n",count);

  array	= malloc(sizeof(int)*count);

  for ( i = 0, p = array ; i < count ; i++ )
    *p++ = i;
  shuffle(array,count);

  add_int(count);
  add_short(count);
  short_sum = (short_sum_u<<16)|short_sum_l;

  if ( int_sum == short_sum)
    printf("OK : %u\n",int_sum);
  else
    printf("NG : %u(int) %u(short)\n",int_sum,short_sum);

  free(array);
  return 0;
}
